(并查集) hdu 4750

Count The Pairs

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
Total Submission(s): 952    Accepted Submission(s): 422

Problem Description


  With the 60th anniversary celebration of Nanjing University of Science and Technology coming soon, the university sets n tourist spots to welcome guests. Of course, Redwood forests in our university and its Orychophragmus violaceus must be recommended as top ten tourist spots, probably the best of all. Some undirected roads are made to connect pairs of tourist spots. For example, from Redwood forests (suppose it’s a) to fountain plaza (suppose it’s b), there may exist an undirected road with its length c. By the way, there is m roads totally here. Accidently, these roads’ length is an integer, and all of them are different. Some of these spots can reach directly or indirectly to some other spots. For guests, they are travelling from tourist spot s to tourist spot t, they can achieve some value f. According to the statistics calculated and recorded by us in last years, We found a strange way to calculate the value f:
  From s to t, there may exist lots of different paths, guests will try every one of them. One particular path is consisted of some undirected roads. When they are travelling in this path, they will try to remember the value of longest road in this path. In the end, guests will remember too many longest roads’ value, so he cannot catch them all. But, one thing which guests will keep it in mind is that the minimal number of all these longest values. And value f is exactly the same with the minimal number.
  Tom200 will recommend pairs (s, t) (start spot, end spot points pair) to guests. P guests will come to visit our university, and every one of them has a requirement for value f, satisfying f>=t. Tom200 needs your help. For each requirement, how many pairs (s, t) you can offer?

Input

Multiple cases, end with EOF.
  First line:n m
  n tourist spots ( 1<n<=10000), spots’ index starts from 0.
  m undirected roads ( 1<m<=500000).

Next m lines, 3 integers, a b c
  From tourist spot a to tourist spot b, its length is c. 0<a, b<n, c(0<c<1000000000), all c are different.

Next one line, 1 integer, p (0<p<=100000)
  It means p guests coming.

Next p line, each line one integer, t(0<=t)
  The value t you need to consider to satisfy f>=t.

Output

For each guest‘s requirement value t, output the number of pairs satisfying f>=t.
  Notice, (1,2), (2,1) are different pairs.

Sample Input

2 1
0 1 2
3
1
2
3
3 3
0 1 2
0 2 4
1 2 5
5
0
2
3
4
5

Sample Output

2
2
0
6
6
4
4
0

Source

2013 ACM/ICPC Asia Regional Nanjing Online

题意:

题目大意:

给一无向图,n个点,m条边,每条边有个长度,且不一样。定义f(i,j)表示从节点i到节点j的所有路径中的最大边权值的最小值。有q个询问,每个询问有个t,求f(i,j)>=t的种数。

从小到大开始枚举啊,相当于最小生成树啊,然后 二分查找答案就好了。。。

#include<iostream>
#include<cstdio>
#include<cstring>
#include<string>
#include<cmath>
#include<cstdlib>
#include<algorithm>
#include<queue>
#include<vector>
#include<set>
#define maxn 500010
using namespace std;
vector<int> ans;
struct node
{
    int x,y,w;
}e[maxn];
int n,m,tot[maxn],q,sum[maxn],fa[maxn];
int find(int x)
{
    return x==fa[x]?x:fa[x]=find(fa[x]);
}
bool cmp(node a,node b)
{
    return a.w<b.w;
}
int main()
{
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        int cnt=1;
        for(int i=0;i<maxn;i++)
        {
            fa[i]=i;
            sum[i]=1;
            tot[i]=0;
        }
        ans.clear();
        for(int i=0;i<m;i++)
        {
            scanf("%d%d%d",&e[i].x,&e[i].y,&e[i].w);
        }
        sort(e,e+m,cmp);
        for(int i=0;i<m;i++)
        {
            int fx,fy;
            fx=find(e[i].x),fy=find(e[i].y);
            if(fx!=fy)
            {
                fa[fx]=fy;
                ans.push_back(e[i].w);
                tot[cnt++]=sum[fx]*sum[fy]*2;
                sum[fy]+=sum[fx];
            }
        }
        for(int i=1;i<cnt;i++)
            tot[i]+=tot[i-1];
        scanf("%d",&q);
        while(q--)
        {
            int x;
            scanf("%d",&x);
            int pos=lower_bound(ans.begin(),ans.end(),x)-ans.begin();
            printf("%d\n",tot[cnt-1]-tot[pos]);
        }
    }
    return 0;
}

  

时间: 2024-10-24 19:04:05

(并查集) hdu 4750的相关文章

并查集 -- HDU 1232 UVALA 3644

并查集: 1 int pa[maxn],Rank[maxn]; 2 ///初始化 x 集合 3 void make_set(int x) 4 { 5 pa[x]=x; 6 Rank[x]=0; 7 } 8 ///递归查找 x 所在的集合 9 int find_set(int x) 10 { 11 if(pa[x]!=x) pa[x]=find_set(pa[x]); 12 return pa[x]; 13 } 14 ///更新根节点,如果不更新可能会暴栈 15 void mix(int x,in

集合问题 离线+并查集 HDU 3938

题目大意:给你n个点,m条边,q个询问,每条边有一个val,每次询问也询问一个val,定义:这样条件的两个点(u,v),使得u->v的的价值就是所有的通路中的的最长的边最短.问满足这样的点对有几个. 思路:我们先将询问和边全部都按照val排序,然后我们知道,并查集是可以用来划分集合的,所以我们就用并查集来维护每一个集合就行了. //看看会不会爆int!数组会不会少了一维! //取物问题一定要小心先手胜利的条件 #include <bits/stdc++.h> using namespac

并查集 hdu 1856

More is better Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 327680/102400 K (Java/Others) Total Submission(s): 16863    Accepted Submission(s): 6205 Problem Description Mr Wang wants some boys to help him with a project. Because the projec

(并查集) hdu 2473

Junk-Mail Filter Time Limit: 15000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6389    Accepted Submission(s): 2025 Problem Description Recognizing junk mails is a tough task. The method used here consists o

分组并查集 hdu 1829

A Bug's Life Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 10063    Accepted Submission(s): 3288 Problem Description Background Professor Hopper is researching the sexual behavior of a rare

(枚举+并查集) hdu 1598

find the most comfortable road Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 4096    Accepted Submission(s): 1768 Problem Description XX星有许多城市,城市之间通过一种奇怪的高速公路SARS(Super Air Roam Structure---超级

(并查集) hdu 3038

How Many Answers Are Wrong Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2856    Accepted Submission(s): 1100 Problem Description TT and FF are ... friends. Uh... very very good friends -_____

(并查集) hdu 3635

Dragon Balls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3443    Accepted Submission(s): 1342 Problem Description Five hundred years later, the number of dragon balls will increase unexpecte

(并查集) hdu 3461

Code Lock Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 1308    Accepted Submission(s): 471 Problem Description A lock you use has a code system to be opened instead of a key. The lock contai